'# MWS Version: Version 2006B.2 - Mar  4 2007 - 21:57:11

'# length = m
'# frequency = MHz
'# time = s
'# frequency range: fmin = 0 fmax = 60


'@ define units

With Units 
     .Geometry "m" 
     .Frequency "MHz" 
     .Time "s" 
     .Temperature "Celsius" 
     .Voltage "V" 
     .Current "A" 
     .Resistance "Ohm" 
     .Conductance "S" 
     .Capacitance "pF" 
     .Inductance "nH" 
End With

'@ new component: component1

Component.New "component1"

'@ define cylinder: component1:solid1

With Cylinder 
     .Reset 
     .Name "solid1" 
     .Component "component1" 
     .Material "PEC" 
     .OuterRadius "0.01" 
     .InnerRadius "0" 
     .Axis "z" 
     .Zrange "0.1", "height" 
     .Xcenter "0" 
     .Ycenter "0" 
     .Segments "0" 
     .Create 
End With

'@ pick face

Pick.PickFaceFromId "component1:solid1", "3"

'@ define cylinder: component1:solid2

With Cylinder 
     .Reset 
     .Name "solid2" 
     .Component "component1" 
     .Material "PEC" 
     .OuterRadius "0.01" 
     .InnerRadius "0" 
     .Axis "z" 
     .Zrange "0", "height" 
     .Xcenter "0" 
     .Ycenter "foldspace" 
     .Segments "0" 
     .Create 
End With

'@ pick face

Pick.PickFaceFromId "component1:solid2", "3"

'@ define cylinder: component1:solid3

With Cylinder 
     .Reset 
     .Name "solid3" 
     .Component "component1" 
     .Material "PEC" 
     .OuterRadius "0.01" 
     .InnerRadius "0" 
     .Axis "y" 
     .Yrange "0", "foldspace" 
     .Xcenter "0" 
     .Zcenter "height-0.01" 
     .Segments "0" 
     .Create 
End With

'@ pick edge

Pick.PickEdgeFromId "component1:solid1", "2", "2"

'@ blend edges of: component1:solid1

Solid.Blend "0.01"

'@ pick edge

Pick.PickEdgeFromId "component1:solid2", "2", "2"

'@ blend edges of: component1:solid2

Solid.Blend "0.01"

'@ clear picks

Pick.ClearAllPicks

'@ define discrete port: 1

With DiscretePort 
     .Reset 
     .PortNumber "1" 
     .Type "SParameter" 
     .Impedance "50.0" 
     .Voltage "1.0" 
     .Current "1.0" 
     .Point1 "0.0", "0.0", "0.1" 
     .Point2 "0.0", "0.0", "0.0" 
     .UsePickedPoints "False" 
     .LocalCoordinates "False" 
     .Monitor "False" 
     .Create 
End With

'@ define background

With Background 
     .Reset 
     .Type "Normal" 
     .Epsilon "1.0" 
     .Mue "1.0" 
     .ThermalType "Normal" 
     .ThermalConductivity "0.0" 
     .XminSpace "0.0" 
     .XmaxSpace "0.0" 
     .YminSpace "0.0" 
     .YmaxSpace "0.0" 
     .ZminSpace "0.0" 
     .ZmaxSpace "0.0" 
     .ApplyInAllDirections "False" 
End With

'@ define frequency range

Solver.FrequencyRange "7", "13"

'@ define boundaries

With Boundary
     .Xmin "expanded open" 
     .Xmax "expanded open" 
     .Ymin "expanded open" 
     .Ymax "expanded open" 
     .Zmin "electric" 
     .Zmax "expanded open" 
     .Xsymmetry "none" 
     .Ysymmetry "none" 
     .Zsymmetry "none" 
     .XminThermal "isothermal" 
     .XmaxThermal "isothermal" 
     .YminThermal "isothermal" 
     .YmaxThermal "isothermal" 
     .ZminThermal "isothermal" 
     .ZmaxThermal "isothermal" 
     .XsymmetryThermal "none" 
     .YsymmetryThermal "none" 
     .ZsymmetryThermal "none" 
     .ApplyInAllDirections "False" 
     .XminTemperature "" 
     .XminTemperatureType "None" 
     .XmaxTemperature "" 
     .XmaxTemperatureType "None" 
     .YminTemperature "" 
     .YminTemperatureType "None" 
     .YmaxTemperature "" 
     .YmaxTemperatureType "None" 
     .ZminTemperature "" 
     .ZminTemperatureType "None" 
     .ZmaxTemperature "" 
     .ZmaxTemperatureType "None" 
End With

'@ define solver parameters

With Solver 
     .CalculationType "TD-S" 
     .StimulationPort "All" 
     .StimulationMode "All" 
     .SteadyStateLimit "-30" 
     .MeshAdaption "False" 
     .AutoNormImpedance "False" 
     .NormingImpedance "50" 
     .CalculateModesOnly "False" 
     .SParaSymmetry "False" 
     .StoreTDResultsInCache "False" 
     .FullDeembedding "False" 
     .UseDistributedComputing "False" 
End With

'@ set mesh properties

With Mesh 
     .UseRatioLimit "True" 
     .RatioLimit "20.0" 
     .LinesPerWavelength "20" 
     .MinimumStepNumber "20" 
     .Automesh "True" 
     .MeshType "PBA" 
End With

'@ define frequency range

Solver.FrequencyRange "5", "16"

'@ set mesh properties

With Mesh 
     .UseRatioLimit "True" 
     .RatioLimit "20.0" 
     .LinesPerWavelength "20" 
     .MinimumStepNumber "25" 
     .Automesh "True" 
     .MeshType "PBA" 
End With

'@ define monitor: e-field (f=7)

With Monitor 
     .Reset 
     .Name "e-field (f=7)" 
     .Dimension "Volume" 
     .Domain "Frequency" 
     .FieldType "Efield" 
     .Frequency "7" 
     .Create 
End With

'@ define farfield monitor: farfield (f=7)

With Monitor 
     .Reset 
     .Name "farfield (f=7)" 
     .Domain "Frequency" 
     .FieldType "Farfield" 
     .Frequency "7" 
     .Create 
End With

'@ define farfield monitor: farfield (f=8)

With Monitor 
     .Reset 
     .Name "farfield (f=8)" 
     .Domain "Frequency" 
     .FieldType "Farfield" 
     .Frequency "8" 
     .Create 
End With

'@ define farfield monitor: farfield (f=9)

With Monitor 
     .Reset 
     .Name "farfield (f=9)" 
     .Domain "Frequency" 
     .FieldType "Farfield" 
     .Frequency "9" 
     .Create 
End With

'@ define farfield monitor: farfield (f=10)

With Monitor 
     .Reset 
     .Name "farfield (f=10)" 
     .Domain "Frequency" 
     .FieldType "Farfield" 
     .Frequency "10" 
     .Create 
End With

'@ define farfield monitor: farfield (f=11)

With Monitor 
     .Reset 
     .Name "farfield (f=11)" 
     .Domain "Frequency" 
     .FieldType "Farfield" 
     .Frequency "11" 
     .Create 
End With

'@ define farfield monitor: farfield (f=12)

With Monitor 
     .Reset 
     .Name "farfield (f=12)" 
     .Domain "Frequency" 
     .FieldType "Farfield" 
     .Frequency "12" 
     .Create 
End With

'@ delete monitor: e-field (f=7)

Monitor.Delete "e-field (f=7)"

'@ define farfield monitor: farfield (f=13)

With Monitor 
     .Reset 
     .Name "farfield (f=13)" 
     .Domain "Frequency" 
     .FieldType "Farfield" 
     .Frequency "13" 
     .Create 
End With

'@ execute macro: Farfield\Broadband Farfield Monitors

Dim cst_fflow  As Double
Dim cst_ffhigh As Double
Dim cst_ffstep As Double
Dim cst_action As String
cst_fflow = 7#
cst_ffhigh = 13#
cst_ffstep = 1#
cst_action = "create"
If cst_action = "create" Then
	StoreGlobalDataValue "Macros\Broadband Farfield Monitors\frq_low" , cst_fflow
	StoreGlobalDataValue "Macros\Broadband Farfield Monitors\frq_high", cst_ffhigh
	StoreGlobalDataValue "Macros\Broadband Farfield Monitors\frq_step", cst_ffstep
	
	Dim cst_ffrq As Double
	Dim ctmp As String
	' safety against rounding errors for upper limit (tiny increase of cst_ffhigh)
	cst_ffhigh = cst_ffhigh + 0.000001 * cst_ffstep
	
	For cst_ffrq=cst_fflow To cst_ffhigh STEP cst_ffstep
		ctmp="ff_"+Replace(Format(cst_ffrq,"00.0000"),",",".")
		With Monitor 
		     .Reset 
		     .Name ctmp 
		     .FieldType "Farfield" 
		     .Frequency Replace(CStr(cst_ffrq), ",", ".") 
		     .Create 
		End With 
	Next cst_ffrq
	
	ScreenUpdating True
End If

'@ delete monitor: farfield (f=7)

Monitor.Delete "farfield (f=7)"

'@ delete monitor: farfield (f=8)

Monitor.Delete "farfield (f=8)"

'@ delete monitor: farfield (f=9)

Monitor.Delete "farfield (f=9)"

'@ delete monitor: farfield (f=10)

Monitor.Delete "farfield (f=10)"

'@ delete monitor: farfield (f=11)

Monitor.Delete "farfield (f=11)"

'@ delete monitor: farfield (f=12)

Monitor.Delete "farfield (f=12)"

'@ delete monitor: farfield (f=13)

Monitor.Delete "farfield (f=13)"

'@ define cylinder: component1:solid4

With Cylinder 
     .Reset 
     .Name "solid4" 
     .Component "component1" 
     .Material "PEC" 
     .OuterRadius "0.02" 
     .InnerRadius "0" 
     .Axis "z" 
     .Zrange "0", "reflectorheight" 
     .Xcenter "-reflectorspace" 
     .Ycenter "0" 
     .Segments "0" 
     .Create 
End With

'@ farfield plot options

With FarfieldPlot 
     .SetColorByValue "True" 
     .DrawStepLines "False" 
     .DrawIsoLongitudeLatitudeLines "False" 
     .SetTheta360 "True" 
     .CartSymRange "True" 
     .SetPlotMode "Gain" 
     .Distance "1" 
     .UseFarfieldApproximation "False" 
     .SetScaleLinear "False" 
     .SetLogRange "40" 
     .DBUnit "0" 
     .EnableFixPlotMaximum "False" 
     .SetFixPlotMaximumValue "1.0" 
     .AlignToMainLobe "False" 
     .Phistart "1.000000e+000", "0.000000e+000", "0.000000e+000" 
     .Thetastart "0.000000e+000", "0.000000e+000", "1.000000e+000" 
     .PolarizationVector "0", "1", "0" 
     .Origin "bbox" 
     .Userorigin "0.000000e+000", "0.000000e+000", "0.000000e+000" 
     .SetUserDecouplingPlane "False" 
     .UseDecouplingPlane "False" 
     .DecouplingPlaneAxis "X" 
     .DecouplingPlanePosition "0.000000e+000" 
     .EnablePhaseCenterCalculation "False" 
     .SetPhaseCenterAngularLimit "30" 
     .SetPhaseCenterComponent "Theta" 
     .SetPhaseCenterPlane "both" 
End With

'@ delete shape: component1:solid4

Solid.Delete "component1:solid4"

'@ define solver parameters

With Solver 
     .CalculationType "TD-S" 
     .StimulationPort "All" 
     .StimulationMode "All" 
     .SteadyStateLimit "-30" 
     .MeshAdaption "False" 
     .AutoNormImpedance "False" 
     .NormingImpedance "50" 
     .CalculateModesOnly "False" 
     .SParaSymmetry "False" 
     .StoreTDResultsInCache "False" 
     .FullDeembedding "False" 
     .UseDistributedComputing "False" 
End With

'@ define frequency range

Solver.FrequencyRange "0", "60"

'@ define solver parameters

With Solver 
     .CalculationType "TD-S" 
     .StimulationPort "All" 
     .StimulationMode "All" 
     .SteadyStateLimit "-30" 
     .MeshAdaption "False" 
     .AutoNormImpedance "False" 
     .NormingImpedance "50" 
     .CalculateModesOnly "False" 
     .SParaSymmetry "False" 
     .StoreTDResultsInCache "False" 
     .FullDeembedding "False" 
     .UseDistributedComputing "False" 
End With 

